/* Asterisk Manager Proxy
   Copyright (c) 2005 David C. Troy <dave@popvox.com>

   This program is free software, distributed under the terms of
   the GNU General Public License.

   Standard I/O Handler
*/

#include "astmanproxy.h"

extern struct mansession *sessions;

/* Return a fully formed message block to session_do for processing */
int _read(struct mansession *s, struct message *m) {
    int res;

    for (;;) {
        res = get_input(s, m->headers[m->hdrcount]);

        if (res > 0) {
            if (*(m->headers[m->hdrcount]) == '\0' ) {
                break;
            } else if (m->hdrcount < MAX_HEADERS - 1)
                m->hdrcount++;
        } else if (res < 0)
            break;
    }

    return res;
}

int _write(struct mansession *s, struct message *m) {
    int i;

    pthread_mutex_lock(&s->lock);
    for (i=0; i<m->hdrcount; i++) {
        write(s->fd, m->headers[i], strlen(m->headers[i]) );
        write(s->fd, "\r\n", 2);
    }
    write(s->fd, "\r\n", 2);
    pthread_mutex_unlock(&s->lock);

    return 0;
}

int _onconnect(struct mansession *s, struct message *m) {

    char banner[100];

    sprintf(banner, "%s/%s\r\n", PROXY_BANNER, PROXY_VERSION);
    pthread_mutex_lock(&s->lock);
    write(s->fd, banner, strlen(banner));
    pthread_mutex_unlock(&s->lock);

    return 0;
}

int _autodisconnect() {
    return 0;
}
